L7. Number of Substrings Containing All Three Characters | 2 Pointers and Sliding Window Playlist

Поделиться
HTML-код
  • Опубликовано: 5 окт 2024
  • Notes/Codes/Problem links under step 10 of A2Z DSA Course: takeuforward.o...
    Entire playlist: • Two Pointer and Slidin...
    Follow us on our other social media handles: linktr.ee/take...

Комментарии • 96

  • @sauravkumar-ln7zh
    @sauravkumar-ln7zh 3 месяца назад +30

    i did this question based on the logic based on previous question
    → We need to monitor every character in the sliding window.
    → For this, we use a map to keep track of the number of each character present in the sliding window.
    → If the number of distinct characters exceeds k, we start removing characters from the back until the size of the map is less than or equal to k.
    → If the count of a certain character becomes zero while removing it from the back, we must erase it from the map to decrease the map's size.
    class Solution {
    public:
    int plzhelp(string s, int k) {

    int i = 0;
    int j = 0;
    unordered_map mp;
    int count = 0;
    while (j < s.length()) {
    mp[s[j]]++;
    while (mp.size() > k) {
    mp[s[i]]--;
    if (mp[s[i]] == 0) {
    mp.erase(s[i]);
    }
    i++;
    }
    count += (j - i + 1);
    j++;
    }
    return count;
    }
    int numberOfSubstrings(string s) {
    int k = 3;
    int count = plzhelp(s, k) - plzhelp(s, k - 1);
    return count;
    }
    };

    • @sauravdhar1696
      @sauravdhar1696 3 месяца назад

      can you explain why you did => int count = plzhelp(s, k) - plzhelp(s, k - 1) ??

    • @Rahul_Mongia
      @Rahul_Mongia 3 месяца назад +2

      @@sauravdhar1696 kyo ki plzhelp(s,k) will return all substring having characters

    • @bhargav.v.m.193
      @bhargav.v.m.193 3 месяца назад +3

      @@Rahul_Mongia can this be avoided by making
      count += (j - i + 1);
      j++;
      to
      if(mpp(mp.size() == k){
      count += (j - i + 1);
      }
      j++;

    • @MaheshPatil-of1zy
      @MaheshPatil-of1zy Месяц назад +1

      But Bro what is the guarantee that the the function you have written return the characters having only a,b,c which obvious count to because it may also return the count having aaa,aab,bba etc. does you have to say something.?

    • @UECSoumyaRay
      @UECSoumyaRay 16 дней назад

      When you are writing "count += (j-i+1)" you are still using the SAME MINIMUM WINDOW CONCEPT. Earlier (j-i+1) used to signify the length of the substring, now it signifies the number of substrings(excluding the ones that have already been counted)

  • @namannema3349
    @namannema3349 5 месяцев назад +39

    i hope striver one day i will build logic like you

  • @artofwrick
    @artofwrick 6 месяцев назад +43

    These questions are very important for contests . The first question is always a string question where you have to generate subarray. For arrays, questions from PREFIX sum comes often

  • @mayank_singh_43
    @mayank_singh_43 3 месяца назад +8

    This problem of counting substring and subarrays always confused me in any contest , now I learned the concept of how to do this. THanks a lot striver bhaiya

  • @AyushEditz-hs6pf
    @AyushEditz-hs6pf 28 дней назад +3

    easy solution using the generic sliding window that we have used till here. Striver's solution is the best though:
    TC= O(2N log3) at worst SC=O(3)
    int n = s.length();
    int left = 0 ;
    int right = 0;
    int counter=0;
    map mpp;
    while( right < n){
    mpp[s[right]]++;
    while(mpp.size() ==3){
    counter+= n - right;
    mpp[s[left]]--;
    if(mpp[s[left]]==0) mpp.erase(s[left]);
    left++;
    }
    right++;
    }
    return counter;

  • @2amCoder
    @2amCoder 6 месяцев назад +6

    the reason you were good at cp.
    i tried many things with this solution but none of them were close good as this last explanation

  • @LinhHoang-ml1qo
    @LinhHoang-ml1qo День назад

    Understood, thank you Striver!

  • @KhushiVerma-y6t
    @KhushiVerma-y6t 4 месяца назад +2

    I was not able to understand this question's approach but you have done it :)

  • @rajalakshmis7308
    @rajalakshmis7308 5 месяцев назад +5

    Thank you, Striver. Before watching this video, I just solved it using your previous lecture pattern.
    But, the approach you used is the best among all.
    import java.util.HashMap;
    public class Solution {
    public static int countSubstring(String s){
    // Write your code here.
    // to find the tot subarray count
    int res = s.length()*(s.length()+1)/2;
    // return tot subarray - subarray which has atmost any 2 characters from a,b,c.
    return res-solve(s);
    }
    // function to find a subarray which has atmost any 2 character from a,b,c
    public static int solve(String s){
    HashMap map = new HashMap();
    int left=0,count=0;
    for(int right=0;right2){
    map.put(s.charAt(left), map.get(s.charAt(left))-1);
    if(map.get(s.charAt(left))==0) map.remove(s.charAt(left));
    left++;
    }
    count+=right-left+1;
    }
    return count;
    }
    }

    • @surendharv795
      @surendharv795 2 месяца назад

      Your Solution is good , but it is failing in the 48 th test case in leetcode.

    • @kartikluthra6621
      @kartikluthra6621 Месяц назад

      @@surendharv795 you need to use long becuase integer might overflow for larger tc

  • @Adarsh-fg5gs
    @Adarsh-fg5gs 4 месяца назад +8

    i did somewhat diffrent as TOtal no of subarrays - subarrays with at most 2 distinct characters and it becomes same as previous question
    int countSubstring(string s) {
    //Total no of subarrays with n characters =n(n+1)/2
    int n=s.size();
    int total=n*(n+1)/2;
    //now write code to find for at most 2 distinct characters
    int acnt=0,bcnt=0,ccnt=0,res=0,l=0,r=0;
    while(r0 && bcnt>0 && ccnt>0){
    if(s[l]=='a')acnt--;
    if(s[l]=='b')bcnt--;
    if(s[l]=='c')ccnt--;
    l++;
    }
    res+=(r-l+1);
    r++;
    }

    return total-res; //total no of subarrays-subarrys with at most two distinct

    }

    • @charchitagarwal589
      @charchitagarwal589 Месяц назад

      How does res+=(r-l+1); gives u all the substrings, this way we used to calculate maxlen

    • @prajwal5817
      @prajwal5817 22 дня назад

      i came to this same solution as well

  • @cheezy_cheez
    @cheezy_cheez 4 месяца назад +3

    best explanation! especially the part where you mentioned why even omiting the if checking would be ok, I was bamboozled haha

  • @saurabhchaudhari4157
    @saurabhchaudhari4157 3 месяца назад +7

    //Another Optimized Approach
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    int n=s.length();
    int cnt=0;
    int left=0;
    int right=0;
    unordered_mapmpp;
    while(right

  • @rlm3227
    @rlm3227 3 месяца назад +1

    The optimised solution is a very clever sol

  • @ManishKumar-dk8hl
    @ManishKumar-dk8hl 6 месяцев назад +12

    optimal :-
    class Solution {
    public int numberOfSubstrings(String s) {
    int len=0;
    int r=0;
    int[] arr=new int[3];
    Arrays.fill(arr,-1);
    while(r

  • @dhruvsandhu2826
    @dhruvsandhu2826 Месяц назад

    Another approach can be ans=all possible substring - string that contain a,b and c together
    all possible substring = n(n+1)/2 and later one is easy to find using 2 pointers approach

  • @ammarhasan70
    @ammarhasan70 20 дней назад

    not watching the video i come to say i have done this question by myself with help of previous teaching thank u striver

  • @aamna5243
    @aamna5243 6 месяцев назад +16

    bhai farishta h tu.

  • @rushidesai2836
    @rushidesai2836 Месяц назад

    This solution is ingenius.

  • @ratishjain2718
    @ratishjain2718 6 месяцев назад +1

    insane approach

  • @hashcodez757
    @hashcodez757 Месяц назад

    "UNDERSTOOD BHAIYA!!"

  • @moonlight-td8ed
    @moonlight-td8ed 3 месяца назад

    mind blown dude... crazy optimal soln

  • @KratiGarg-ue1ph
    @KratiGarg-ue1ph 4 месяца назад

    I tried the approach you gave in the binary subarray question (number of total subarrays(n*(n+1)/2) - the subarrays where mapcount < 3. that also worked. Please give tips on how to approach a question like this!

  • @techyguyaditya
    @techyguyaditya 6 месяцев назад

    This took a bit of time to understand for optimal approach. I was literally trying to derive mathematical formula which only passes the test case shown in video, further optimizing the code. But the edge case is that, L may not update in other test cases. Basic approach: Find left value of minimum sliding window in each iteration (start finding once a,b,c gets it's value other than -1). Then basically, for each iter, ctr += 1 + L (where L is leftmost index of window, min(a,b,c)).
    Striver said to omit if statement, because 1 + (-1) = 0. I disagree with that, because if you see low level programming, the unnecessary write operation happens to the memory even if the value remains the same. Write operations are generally considered as costly operation. Even if it's for 1 extra line of code, it will prevent the costly write operation just by having read operation, further optimizing the code.

  • @MohdYaqoob-s3k
    @MohdYaqoob-s3k 26 дней назад

    this was a tough one

  • @square-kstudios9561
    @square-kstudios9561 5 месяцев назад +1

    Great explanation! How does one come up with a solution like this in the constraints of an interview though, if we haven't seen it ever in the past? Some companies only give you 15 mins to come up with a solution, explain it, dry run it, code it and then provide the time/space complexity.

  • @ganeshjaggineni4097
    @ganeshjaggineni4097 3 месяца назад

    NICE SUPER EXCELLENT MOTIVATED

  • @ujjwalkashyap9196
    @ujjwalkashyap9196 6 месяцев назад +1

    Please update the site also with all the upcoming videos 🙏

  • @oyeesharme
    @oyeesharme Месяц назад

    understood bhaiya

  • @chandnikumari6978
    @chandnikumari6978 21 день назад

    Please upload note of the lecture on a2z sheet .

  • @nihalsingh6233
    @nihalsingh6233 17 дней назад

    int numberOfSubstrings(string s) {
    int count = 0;
    int left = 0;
    int right = 0;
    int size = s.size();
    unordered_mapmp;
    while(right < size)
    {
    mp[s[right]]++;
    while(mp.size() == 3)
    {
    count += size - right;
    mp[s[left]]--;
    if(mp[s[left]] == 0) mp.erase(s[left]);
    left++;
    }

    right++;
    }
    return count;
    }

  • @akay5797
    @akay5797 2 месяца назад

    Mindblown

  • @sunitsable2752
    @sunitsable2752 5 месяцев назад

    amazing logic!!!

  • @niladri_c
    @niladri_c 29 дней назад

    My own O(2n) soln.
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    // better approach
    // sliding window
    // let's see if it works.
    // taking the variables
    int n = s.length();
    int l = 0, r = 0, cnt = 0, a = 0, b = 0, c = 0;

    //checking from start to end
    while(r < n){

    if(s[r] == 'a') a++;
    if(s[r] == 'b') b++;
    if(s[r] == 'c') c++;
    // if for a r and l, a >= 1, b >= 1, c >= 1, then for all following r and fixed l, the substring is valid
    while(a>=1 && b>=1 && c>=1){
    //we are checking till the l for which condition is valid, for that, we don't need to increase r, and add (n - r) to count for each while
    cnt += (n - r);
    if(s[l] == 'a') a--;
    if(s[l] == 'b') b--;
    if(s[l] == 'c') c--;
    l++;
    }
    r++;
    }

    return cnt;
    }
    };

  • @codeman3828
    @codeman3828 5 месяцев назад

    Understood. great

  • @abhinayrk985
    @abhinayrk985 5 месяцев назад

    Outstanding

  • @AkOp-bf9vm
    @AkOp-bf9vm 2 месяца назад

    the line if(hash[0]!=-1 && ...) is not compulsory, the code will work fine without this line because -1+1=0 and if 0 is added to Count it didn't impact the answer

  • @rider5584
    @rider5584 2 месяца назад

    here is the java code =
    class Solution {
    public int numberOfSubstrings(String s) {
    // Array to store the latest positions of characters 'a', 'b', and 'c'
    int[] latestPosition = new int[] {-1, -1, -1};

    // This will hold the count of valid substrings
    int answer = 0;

    // Iterate over each character in the string
    for (int i = 0; i < s.length(); ++i) {
    char currentChar = s.charAt(i);

    // Update the latest position of the current character
    latestPosition[currentChar - 'a'] = i;

    // Find the smallest index among the latest positions of 'a', 'b', and 'c'
    // and add 1 to get the count of valid substrings ending with the current character
    int minPosition = Math.min(latestPosition[0], Math.min(latestPosition[1], latestPosition[2]));
    answer += minPosition + 1;
    }

    return answer; // Return the total count of valid substrings
    }
    }

  • @Arya20012
    @Arya20012 6 месяцев назад

    what a grate solution,just love this,thank u brother

  • @animexworld6614
    @animexworld6614 6 месяцев назад +2

    My question is what is your favorite colour

  • @tanishqtyagi1465
    @tanishqtyagi1465 4 месяца назад

    The series is dam good!! 🤍🤍💯

  • @saakshishekhar237
    @saakshishekhar237 6 месяцев назад +6

    int numberOfSubstrings(string s) {
    vector lastSeen(3,-1);
    int cnt = 0;
    for(int i=0; i

    • @sakethsenapathi8323
      @sakethsenapathi8323 6 месяцев назад

      i didnt get what is lastseen[s[i] - 'a'] = i part can u please explain.

    • @ManishKumar-dk8hl
      @ManishKumar-dk8hl 6 месяцев назад +2

      @@sakethsenapathi8323 s[i] character represent kr raha h aur jb unme 'a' minus hoga too a-a=0 ; b-a=1 ;c-a =2 ayega then lastseen wali array k index pr string k character ka index store hoyega . index 0 of array=a, index 2= b,index 2=c

  • @CE_113_Katyayni
    @CE_113_Katyayni 5 месяцев назад +2

    sir your brute force approach is actually wrong because when we sum the hash[0]+hash[1]+hash[2] ==3 here it may be the case that hash[1]=0 and hash[0]=2 in this case also the if state would be true and cnt will increase which is actually wrong

    • @rohitvishwakarma7046
      @rohitvishwakarma7046 5 месяцев назад

      Yeah, I think he meant to take the size of hashmap , hope you get it.

    • @azizkavas6993
      @azizkavas6993 5 месяцев назад +3

      No such case is possible because hash doesnt count the number of occurance instead it just sign the related index. If you try yourself with sample code you will see what I mean. Kind regards.

    • @ashnidahiya8347
      @ashnidahiya8347 3 месяца назад

      This is a brute force approach using sets, hope it helps:
      int countSubStrings(string str, int k)
      {
      set st;
      int count = 0;
      int n = str.length();
      for(int i=0;i

    • @sparksfly4421
      @sparksfly4421 3 месяца назад +2

      his code in brute force is correct. The hash array only gets assigned a truthy value (1) at the index of the given alphabet (where index(a) = 0, index(b)=1, index(c)=2) if it happens on the given letter in the string. It can never increment beyond that since it's an assignment operator

    • @prabhavtrivedi
      @prabhavtrivedi Месяц назад

      @@ashnidahiya8347 setst

  • @dipendrasingh4874
    @dipendrasingh4874 6 месяцев назад

    thank you bhaiya ...
    please tcs nqt segment i was solving them but u removed that from site .....(or i am not able to find it )please add
    thank you

  • @subee128
    @subee128 6 месяцев назад

    Thanks

  • @RonitTejani
    @RonitTejani 3 месяца назад

    Legit God

  • @tradester6699
    @tradester6699 Месяц назад +1

    class Solution {
    public:
    int numberOfSubstrings(string s) {
    int n = s.size();
    int ans = 0;
    vector arr(3,-1);
    for(int i=0; i

  • @sobhansahoosubh3873
    @sobhansahoosubh3873 3 месяца назад +3

    we also do like this way int numberOfSubstrings(string s) {

    int n = s.size();
    int l = 0,r = 0,count = 0;
    unordered_map mp;
    while(r < n) {
    mp[s[r]]++;
    while(mp['a'] >= 1 && mp['b'] >= 1 && mp['c'] >= 1 ) {
    count = count + (n - r);
    mp[s[l]]--;
    l++;
    }
    r++;
    }
    return count;
    }

  • @shivisingh9975
    @shivisingh9975 5 месяцев назад

    Understood!

  • @adilkevin6220
    @adilkevin6220 5 месяцев назад

    Document link is not attached for some of the program

  • @shashankvashishtha4454
    @shashankvashishtha4454 2 месяца назад

    understood

  • @iamnottech8918
    @iamnottech8918 2 месяца назад +1

    I solved this ,this way it is easy appproach
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    int a,b,c;
    a=b=c=0;
    int l=0;int r=0;
    int len=0;
    while(r=1 && b>=1 && c>=1){
    // len++;
    len=len +(s.length()-r);
    if(s[l]=='a') a--;
    else if(s[l]=='b') b--;
    else if(s[l]=='c') c--;

    l++;
    }
    r++;

    }
    return len;
    }
    };

  • @expanse8846
    @expanse8846 2 месяца назад

    Another solution using previous video method
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    vectorhashh(3,0);
    int l=0,r=0,n=s.size();
    int ct=0;
    // vectordis;
    while(r0 && hashh[1]>0 && hashh[2]>0)
    {
    ct+= n-r;
    hashh[s[l]-'a']--;
    // dis.push_back(ct);
    l++;
    }
    r++;

    }
    // for(int i=0;i

  • @adityapandey23
    @adityapandey23 2 месяца назад

    Understood

  • @LockingIn8008
    @LockingIn8008 12 дней назад

    class Solution {
    public:
    int numberOfSubstrings(string s) {
    int n = s.length();
    int l=0;
    int r=0;
    int cnt = 0;
    unordered_map mpp; //character and its frequency
    while(r=3){
    cnt = cnt + (n-r);
    mpp[s[l]]--;
    if(mpp[s[l]]==0) mpp.erase(s[l]);
    l++;
    }
    if(mpp.size()

  • @nirbhaysingh7971
    @nirbhaysingh7971 6 месяцев назад +2

    #include
    int countSubstring(string s){
    // Write your code here.
    int n = s.size();
    int left = 0;
    int right = 0;
    map mpp;
    int cnt = 0;
    while(right

  • @socify4410
    @socify4410 4 месяца назад

    fabolous

  • @karthik-varma-1579
    @karthik-varma-1579 8 дней назад

    class Solution {
    public int numberOfSubstrings(String s) {
    int n = s.length();
    int l=0,r=0,count=0;
    int lastSeen[] = {-1,-1,-1};
    for(int i=0;i

  • @omkarsawant9267
    @omkarsawant9267 3 месяца назад

    #include
    #include
    #include
    #include
    using namespace std;
    // Function to count the number of substrings containing all three characters 'a', 'b', and 'c'
    pair numberOfSubstrings(string s) {
    // Hashmap to store the count of 'a', 'b', and 'c' in the current window
    unordered_map count;
    int left = 0, result = 0;
    vector substrings;

    // Iterate over the string with 'right' as the end of the window
    for (int right = 0; right < s.length(); ++right) {
    // Increment the count of the current character
    count[s[right]]++;

    // Check if all three characters are present in the current window
    while (count['a'] > 0 && count['b'] > 0 && count['c'] > 0) {
    // If yes, add all possible substrings starting from the current 'left' to 'right'
    result += s.length() - right;

    // Capture the substrings
    for (int k = right; k < s.length(); ++k) {
    substrings.push_back(s.substr(left, k - left + 1));
    }

    // Move the left end of the window to the right
    count[s[left]]--;
    left++;
    }
    }

    return {result, substrings};
    }
    int main() {
    string s = "abcabc";
    auto result = numberOfSubstrings(s);
    cout

  • @Flash-qr5oh
    @Flash-qr5oh 4 месяца назад

    WoW!

  • @angeldeveloper
    @angeldeveloper 6 месяцев назад

    ❤👍

  • @user-fw4kz3bb4g
    @user-fw4kz3bb4g 4 месяца назад

    EASIEST APPROACH (C++)
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    int left=0, right=0,count=0;
    vectorarr(3,0);
    while(right0 && arr[1]>0 && arr[2]>0){
    count+=s.size()-right;
    arr[s[left]-'a']--;
    left++;
    }
    right++;
    }
    return count;
    }
    };

  • @gocrazy7362
    @gocrazy7362 3 месяца назад +1

    unordered_map mp;
    int l = 0,r=0,cnt = 0;
    while(r=1 && mp['b']>=1 && mp['c']>=1){
    cnt += s.size() - r;
    mp[s[l]]--;
    l++;
    }
    r++;

    }
    return cnt;

  • @doremon81072
    @doremon81072 4 месяца назад

    demm man

  • @Bhai9866
    @Bhai9866 6 месяцев назад

    public int numberOfSubstrings(String s) {
    int[] lastSeen = new int[3];
    Arrays.fill(lastSeen, -1);
    int cnt = 0;
    for (int i = 0; i < s.length(); i++) {
    char c = s.charAt(i);
    lastSeen[c - 'a'] = i;
    if (lastSeen[0] != -1 && lastSeen[1] != -1 && lastSeen[2] != -1) {
    cnt += (1 + Math.min(lastSeen[0], Math.min(lastSeen[1], lastSeen[2])));
    }
    }
    return cnt;
    }

  • @CHILLBRO-e7y
    @CHILLBRO-e7y 2 месяца назад

    i wrote a O(n) code but it gives only 36% better i dont know why and how can i improve it further? class Solution {
    public:
    int numberOfSubstrings(string s) {
    int l=0;
    int n=s.size();
    unordered_map index;
    int ans=0;
    for(int r=0;r

  • @KartikeyTT
    @KartikeyTT 6 месяцев назад +1

    If someone can debug this solution then they are real genius
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    map map;
    int l = 0;
    int r = 0;
    int count = 0;
    int minValue=0;
    while (map.size() != 3) {
    map[s[r]] = r;
    r++;
    }
    while (r < s.length()) {
    minValue=INT_MAX;
    for (const auto& pair : map) {
    cout

  • @anmolvanced3262
    @anmolvanced3262 3 месяца назад +10

    viewed multiple times .. but your explanation is not good .. sorry to say!

  • @ShubhamMIshra-hv5nz
    @ShubhamMIshra-hv5nz 5 месяцев назад

    CODE FOR THEOPTIMISED SOLUTION!!!!!
    class Solution {
    public:
    int numberOfSubstrings(string s) {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int count =0;
    int length=s.size();
    int lastSceen[3]={-1,-1,-1};
    for(int i =0; i < length; i++){
    lastSceen[s[i]-'a']=i;
    if(lastSceen[0] != -1 && lastSceen[1]!= -1&& lastSceen[2]!=-1) {
    count += min(lastSceen[0],min(lastSceen[1],lastSceen[2])) +1;
    }
    }
    return count;
    }
    };
    whats up??

  • @KartikeyTT
    @KartikeyTT 6 месяцев назад

    If you want to find minimum of three elements in cpp. You can do it like this-
    int temp = min(arr[0],arr[1]);
    int lowestI = min(temp, arr[2]);

    • @AnujGupta-xi5ep
      @AnujGupta-xi5ep 6 месяцев назад +3

      For one liner you can do : int ans = min({arr[0], arr[1], arr[2]});

    • @KartikeyTT
      @KartikeyTT 6 месяцев назад +1

      @@AnujGupta-xi5ep ohhh, i was doin without the braces and was getting error, so i thought it wasn’t possible in cpp

  • @adityababu3405
    @adityababu3405 3 месяца назад

    int numberOfSubstrings(string s) {
    vector lastSeen(3,-1);
    int cnt = 0;
    for(int i=0; i